
#include "OmSourceProcessDlg.h"
#include <qapplication.h>
#include <qpushbutton.h>
#include <qdialog.h>
#include "OmSourceVersionNo.h"
#include <qstring.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qmessagebox.h>
#include <ExceptionErrorHandler.h>
#include <qtimer.h>
#include <qcheckbox.h>
#include <qdatetime.h>

#include "OmImageDisplay.h"
#include "OmSourceRun.h"
#include <Dal.h>
#include <ExceptionErrorHandler.h>
#include <param.h>
#include <param.h>
#include <errstr.h>
#include <omatt.h>
#include <ommag.h>


F90MODPROCPROTO(void, omsource_glue, finish)();


/********************************************************************************
 * Dialog for running omdetect- allows you to change the parameters nsigma
 * and minsignificance.          
 *
 *******************************************************************************/

ProcessDlg::ProcessDlg(QWidget *parent, int no, QString caption, void (*function)(int sourceNo)) :
  QDialog(parent, "", true), _sourceNo(no), _caption(caption), Function1(function)
{

    QDateTime date = QDateTime::currentDateTime();
  
    QString text; 
    text.sprintf("%s, %s", (const char*)omsourceVersionNo(),  
                    (const char*)date.toString());
    //cout<<"L46 ProcessDlg..."<<endl;
    setCaption(text);

    _label = new QLabel(this);
    _label->setGeometry(10, 10, 400, 100);
  
    _label->setFrameStyle( QFrame::Panel | QFrame::Raised );
  
    //  qApp->processEvents();

  //   _label->setText(_caption);
    

   //    runProcess();
    
    pause1();
    
};
/***********************************************************************
 *
 **********************************************************************/
ProcessDlg::ProcessDlg(QWidget *parent, OmSourceParameters *source, 
           QString caption, 
           void (*function)(OmSourceParameters *source)) :
  QDialog(parent, "", true), _source(source), _caption(caption), Function2(function)
{

    QDateTime date = QDateTime::currentDateTime();
  
    QString text; 
    text.sprintf("%s, %s", (const char*)omsourceVersionNo(),  
                    (const char*)date.toString());
    //cout<<"L78 ProcessDlg ... "<<endl;
    setCaption(text);

    _label = new QLabel(this);
    _label->setGeometry(10, 10, 400, 100);
  
    _label->setFrameStyle( QFrame::Panel | QFrame::Raised );
  
    
    pause2();
    
};


/***********************************************************************
 *
 **********************************************************************/
ProcessDlg::ProcessDlg(QWidget *parent, void (*function)()) :
  QDialog(parent, "", true), Function3(function)
{

    QDateTime date = QDateTime::currentDateTime();
  
    QString text; 
    text.sprintf("%s, %s", (const char*)omsourceVersionNo(),  
                    (const char*)date.toString());
    //cout<<"L104 ProcessDlg ... "<<endl;
    setCaption(text);

    _label = new QLabel(this);
    _label->setGeometry(10, 10, 400, 100);
  
    _label->setFrameStyle( QFrame::Panel | QFrame::Raised );
  
    
    pause3();
    
};



/*******************************************************************
* NB Need this routine to allow the widget changes to be made
*
*******************************************************************/
void ProcessDlg::pause1()
{     
    _label->setText(_caption);
                 
    //    QFont serifFont( "Times", 20, QFont::Bold );
   
    //   _label->setFont(serifFont);

    //    repaint();
    
    //    QTimer *timer = new QTimer(this);

    //    connect(timer, SIGNAL(timeout()), this, SLOT(runProcess1()));
    //    timer->start(100, TRUE);

    QTimer::singleShot(500, this, SLOT(runProcess1()));
}



/*******************************************************************
* NB Need this routine to allow the widget changes to be made
*
*******************************************************************/
void ProcessDlg::pause2()
{     

    _label->setText(_caption);
                 
    //    QFont serifFont( "Times", 20, QFont::Bold );
   
    //   _label->setFont(serifFont);

    //    repaint();
  
    //    QTimer *timer = new QTimer(this);
    //    connect(timer, SIGNAL(timeout()), this, SLOT(runProcess2()));
    //    timer->start(100, TRUE);

   
  QTimer::singleShot(500, this, SLOT(runProcess2()));

}


/*******************************************************************
* NB Need this routine to allow the widget changes to be made
*
*******************************************************************/
void ProcessDlg::pause3()
{     

    _label->setText(_caption);
                 
   
  QTimer::singleShot(500, this, SLOT(runProcess3()));

}







/***************************************************************
 *
 **************************************************************/
void ProcessDlg::runProcess1()
{
  //  for(int i = 0; i < 30; i++)    
    //  QApplication::messagBeep();
  (* Function1)(_sourceNo);

   done(10);   
    
}
/***************************************************************
 *
 **************************************************************/
void ProcessDlg::runProcess2()
{
    


    (* Function2)(_source);



   done(10);   
    
}

/***************************************************************
 *
 **************************************************************/
void ProcessDlg::runProcess3()
{
    


    (* Function3)();



   done(10);   
    
}




/***************************************************************
 *
 **************************************************************/
void ProcessDlg::createNewSourceListFile(int )
{

    
    F90MODPROC(omsource_glue, finish)();

          // Need to run ommag and omatt

    //    ExceptionErrorHandler local;
    //   ErrorHandler* oldHandler = errHandler.handler(&local);
    //    const bool invoke = true;
 
    //    Info::Task *t;
 
    //    t = task("omatt");	  
    //    t->setParameter("set", stringParameter("imageset"));
    //    t->setParameter("sourcelistset", stringParameter("newsrclistset"));
    //    t->setParameter("ppsoswset",  stringParameter("newsrclistset"));
    //   t->setParameter("rotateimage", false);
      
    string command = "omatt set=" + stringParameter("imageset") + 
      " sourcelistset=" +  stringParameter("newsrclistset") +
      " ppsoswset=" +  stringParameter("newsrclistset") + " rotateimage=false";
    system(command.c_str());    	  
    //    try {
    //	t->exec(invoke);
	//    }
	//    catch (SasException::Error e) {
	//        QString message(e.message.c_str());
	//	message += "\nReturn to main window or exit program?";

	//	switch( QMessageBox::warning(0, t->name(), message, "main window", "exit", QString::null, 0, 1)) 
	//       {
	//	    case 0: // Try again or Enter
	//              errHandler.handler(oldHandler);
	
	//	        return;
	        // try again
	 
	//	    case 1: // Quit or Escape
	    // exit
	//	        errHandler.handler(oldHandler);
	        
	//	 }
	//    }
	//    errHandler.handler(oldHandler); // return to default error handler

}    












